import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.ArrayList;

public class ConfirmDialog extends JFrame
{	static final long serialVersionUID=(long)0.0;
	JButton close,startGame,decline;
	String name,opponentName,gameType,mapType;
	JTextField nameField,opponentNameField,gameTypeField,MapTypeField,
	nameInfo,opponentNameInfo,gameTypeInfo,MapTypeInfo;
	int number;
	boolean random;
	Client client;
	ArrayList challengers;
	public ConfirmDialog(Client c,int n,String g,String m,boolean r)
	{	super("Seek");
		client=c;
		number=n;
		gameType=g;
		mapType=m;
		random=r;
		name=client.name;
		challengers=new ArrayList();
		opponentName="Waiting on opponent...";
		close=new JButton("Close");
		close.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	client.withdrawSeek(number);
				close();
			}
		});
		startGame=new JButton("Start Game");
		startGame.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	client.seekConfirmed(number,opponentName);
				close();
			}
		});
		decline=new JButton("Decline");
		decline.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	client.seekDeclined(number,opponentName);
				challengers.remove(0);
				String nextChallenger="Waiting on opponent...";
				if(challengers.size()==0)
				{	startGame.setEnabled(false);
    				decline.setEnabled(false);
				}else nextChallenger=(String)challengers.get(0);
				opponentName=nextChallenger;
				opponentNameInfo.setText(nextChallenger);
			}
		});
		startGame.setEnabled(false);
		decline.setEnabled(false);
		nameField=new JTextField();
		nameField.setEditable(false);
		nameField.setFont(new Font("Arial",Font.BOLD,14));
		nameField.setText("Your Name");
		opponentNameField=new JTextField();
		opponentNameField.setEditable(false);
		opponentNameField.setFont(new Font("Arial",Font.BOLD,14));
		opponentNameField.setText("Opponents Name");
		gameTypeField=new JTextField();
		gameTypeField.setEditable(false);
		gameTypeField.setFont(new Font("Arial",Font.BOLD,14));
		gameTypeField.setText("Game Type");
		MapTypeField=new JTextField();
		MapTypeField.setEditable(false);
		MapTypeField.setFont(new Font("Arial",Font.BOLD,14));
		MapTypeField.setText("Map");
		nameInfo=new JTextField();
		nameInfo.setEditable(false);
		nameInfo.setText(name);
		opponentNameInfo=new JTextField();
		opponentNameInfo.setEditable(false);
		opponentNameInfo.setText(opponentName);
		gameTypeInfo=new JTextField();
		gameTypeInfo.setEditable(false);
		gameTypeInfo.setText(gameType);
		MapTypeInfo=new JTextField();
		MapTypeInfo.setEditable(false);
		MapTypeInfo.setText(mapString());
		JPanel fields=new JPanel(),buttons=new JPanel();
		fields.setLayout(new GridLayout(0,2));
		fields.add(nameField);
		fields.add(nameInfo);
		fields.add(opponentNameField);
		fields.add(opponentNameInfo);
		fields.add(gameTypeField);
		fields.add(gameTypeInfo);
		fields.add(MapTypeField);
		fields.add(MapTypeInfo);
		buttons.setLayout(new FlowLayout());
		buttons.add(startGame);
		buttons.add(decline);
		buttons.add(close);
		Container cc=getContentPane();
		cc.setLayout(new BorderLayout());
		cc.add(fields);
		cc.add(buttons,"South");
		pack();
		setSize(300,300);
		setVisible(true);
	}
	public void challenger(String s)
	{	if(opponentName.equals("Waiting on opponent..."))
		{	opponentName=s;
			opponentNameInfo.setText(s);
			startGame.setEnabled(true);
			decline.setEnabled(true);
		}
		challengers.add(s);
	}
	public String mapString()
	{	String mapString=mapType;
		if(random)mapString+="(r)";
		return mapString;
	}
	public void close()
	{	client.confirmDialogs.remove(this);
		setVisible(false);
		client.withdrawSeek(number);
	}
}