import java.util.ArrayList;
public class Hand
{	
	int[][] playersPieces;
	ArrayList pieceNames; //<String>
	
	public Hand(int p)
	{	playersPieces=new int[p+1][15];
		pieceNames=new ArrayList(); //<String>
		int i,j;
		for(i=0;i<=p;i++)
			for(j=0;j<15;j++)
				playersPieces[i][j]=0;
		addAllPieces();
	}
	public Hand(Hand h)
	{	int length=h.playersPieces.length;
		playersPieces=new int[length][15];
		pieceNames=new ArrayList(); //<String>
		int i,j;
		for(i=0;i<length;i++)
			for(j=0;j<15;j++)
				playersPieces[i][j]=h.playersPieces[i][j];
		addAllPieces();
	}
	public void addAllPieces()
	{	String[] p={"Bishop","Doppelganger","Farm","Chicken","Grenade",
			"Knight","Lover","Pawn","Penguin","Phoenix",
			"Psychic","Queen","Rook","Tank","King"};
		for(int j=0;j<15;j++)
			pieceNames.add(p[j]);
	}
	public boolean canTakeAsPrisoner(String s)
	{	return indexOfPiece(s)==-1;
	}
	public int indexOfPiece(String s)
	{	return pieceNames.indexOf(s);
	}
	public void addCapture(String s, int c)
	{	playersPieces[c][indexOfPiece(s)]++;
	}
	public boolean inHand(String s, int c)
	{	for(int j=0;j<15;j++)
			if(pieceNames.get(j).equals(s))
			{	if(playersPieces[c][j]>0)return true;
				return false;
			}
		return false;
	}
	public ArrayList allPiecesInHand(int c) //<String>
	{	ArrayList ret=new ArrayList(); //<String>
		for(int j=0;j<15;j++)
		{	String thisElem=(String)pieceNames.get(j);
			if(inHand(thisElem, c))
				ret.add(thisElem);
		}
		return ret;
	}
	public int ammountInHand(int c)
	{	return allPiecesInHand(c).size();
	}
	public boolean empty(int c)
	{	return ammountInHand(c)==0;
	}
	public boolean empty()
	{	for(int i=1;i<playersPieces.length;i++)
			if(!empty(i))return false;
		return true;
	}
	public void drop(String type,int c)
	{	playersPieces[c][indexOfPiece(type)]--;
	}
	public String randomDrop(int c)
	{	String[] p={"Bishop","Doppelganger","Farm","Chicken","Grenade",
			"Knight","Lover","Pawn","Penguin","Phoenix",
			"Psychic","Queen","Rook","Tank"};
		for(int j=0;j<14;j++)
		{	String t=p[j];
			if(inHand(t, c))
			{	drop(t,c);
				return t;
			}
		}
		return "Nothing";		
	}
	public String toString()
	{	String ret="";
		int i,j;
		for(i=1;i<playersPieces.length;i++)
		{	for(j=0;j<15;j++)
				ret+=playersPieces[i][j]+" ";
			ret+="\n";
		}
		return ret;
	}
}