import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

public class HelpMenu extends JFrame
{	static final long serialVersionUID=(long)0.0;
	JList helpList;
	JButton closeButton;
	JRadioButton pieces,twoPlayer,fourPlayer,twoBoard;
	JPanel radioPanel,choicePanel;
	int chosen;
	MouseListener helpListener;
	JTextArea printMessage;
	String[] messages,
	twoMessages={
	"This is the same as normal chess\nwith three differences:\n1. Stalemate is a loss\n2. You cannot repeat a board position\n3. No en passant",
	"When you capture a piece it goes\ninto your “hand”.  Instead of moving,\nany turn you may drop a piece\non an unoccupied square.",
	"When a capture is made,\nthe capturing piece dies, and all next\nto it except pawns do also",
	"After a piece moves, you look\nin all four directions, if the closest\npiece is a friendly piece push it away\nas far as it can go, if its the opposite\ncolor attract it next to it",
	"Goal is to not be able to move,\nif you can capture you must",
	"First player gets one move,\nsecond two, etc, if you\ngive check turn over",
	"Players can only see what they\nare attacking, and own pieces",
	"You can only move pieces you\nare attacking (including opponents)",
	"Your pieces cannot move backwards,\npieces on back row can move anywhere",
	"When a capture is made, just\nremove the captured piece,\ndo not move the capturing piece",
	"All pieces move like those next to\nthem instead of themselves,\npawns have a max range of 2 squares",
	"Semi-random starting position,\nplay one game as each side,\nred cannot check on first move",
	"All pieces but king start in\nhand, and may only drop on your\nside of the board",
	"If you lose one piece\ntype you lose game",
	"Whoever captures all\npawns first wins",
	}
	,fourMessages={
	"Team win, your partner is across from\nyou, cant capture partners pieces",
	"Each player target is to their\nright, whoever's target dies first wins",
	"When you capture a piece it goes\ninto your “hand”.  Instead of moving,\nyou may drop a piece from your hand onto\nan unoccupied square.",
	"Your pieces cannot move backwards,\npieces on back row can move anywhere",
	"Game ends when only one army left,\nat beginning all empty squares\nbecome gold coins,\nwinner based on points, you get a point\nfor each capture you make",
	"Assassination, but target is across,\nand you cannot capture any pieces\nbut your targets",
	}
	,twoXTwoMessages={
	"Partner plays opposite color,\nwhen you capture a piece your partner gets\nit like in crazyhouse, if one person wins\nthen his team does",
	"Two boards, you play same color as\npartner, if one player wins team win,\nyou may move to respective square on partners\nboard if it is empty",
	}
	,piecesMessages={
	"Moves as a bishop or knight,\nwill only move next to a\nfriendly piece",
	"Moves like what is next to it",
	"Can't do anything",
	"Moves like a king, if you\ncapture it you die",
	"Moves as a bishop, cannot\nmake captures, enemy pieces\nnext to it cannot move",
	"Swap with a piece within two\nsquares of it, except a king",
	"Moves like a rook and knight,\nbut if it makes a capture it dies",
	"Moves like a rook, cannot make captures,\ncan use enemy pieces next to it",
	"Moves to any square next to it,\ninstead of capturing \"pushes,\"\ncan push stuff off board",
	"Can't capture it,\nused in four player on corners",
	};
	public HelpMenu()
	{	super("Help Contents");
		printMessage=new JTextArea();
		printMessage.setEditable(false);
    	setToPieces();
    	pieces=new JRadioButton("Pieces");
    	pieces.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	setToPieces();
				packStuff();
			}
		});
    	twoPlayer=new JRadioButton("Two Player Games");
    	twoPlayer.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	setToTwoPlayer();
				packStuff();
			}
		});
    	fourPlayer=new JRadioButton("Four Player Games");
    	fourPlayer.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	setToFourPlayer();
				packStuff();
			}
		});
    	twoBoard=new JRadioButton("Two Boarded Games");
    	twoBoard.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	setToTwoBoard();
				packStuff();
			}
		});
    	closeButton=new JButton("Close");
    	closeButton.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	setVisible(false);
			}
		});
    	ButtonGroup group=new ButtonGroup();
    	group.add(pieces);
    	group.add(twoPlayer);
    	group.add(fourPlayer);
    	group.add(twoBoard);
    	choicePanel=new JPanel(new GridLayout(0,1));
    	choicePanel.add(pieces);
    	choicePanel.add(twoPlayer);
    	choicePanel.add(fourPlayer);
    	choicePanel.add(twoBoard);
    	packStuff();
	}
	public void packStuff()
	{	JPanel okAndChange=new JPanel();
    	okAndChange.setLayout(new BorderLayout());
    	okAndChange.add(choicePanel,"North");
    	okAndChange.add(closeButton);
    	Container c=getContentPane();
		c.removeAll();
		c.setLayout(new BorderLayout());
    	c.add(new JScrollPane(helpList),"North");
    	c.add(printMessage);
    	c.add(okAndChange,"South");
    	pack();
    	setSize(300,400);
    	setResizable(false);
    	setVisible(true);
	}
	public void setToPieces()
	{	chosen=2;
		String[] games={"Chicken","Doppelganger","Farm","Grenade",
				"Lover","Penguin","Phoenix","Psychic","Tank","Mountain"};
    	helpList=new JList(games);
    	helpList.setVisibleRowCount(10);
    	helpList.setSelectedValue(games[0],true);
    	addHelpListener();
    	messages=twoMessages;
    	printMessage.setText(messages[0]);
	}
	public void setToTwoPlayer()
	{	chosen=2;
		String[] games={"Regular","Crazyhouse","Atomic","Magnetic",
    			"Suicide","Progressive","Fog of War","Power",
    			"Checkers","Rifles","Absorption","Chaos",
    			"Paratrooper","Extinction","Peasant"};
    	helpList=new JList(games);
    	helpList.setVisibleRowCount(10);
    	helpList.setSelectedValue(games[0],true);
    	addHelpListener();
    	messages=twoMessages;
    	printMessage.setText(messages[0]);
	}
	public void setToFourPlayer()
	{	chosen=4;
		String[] games={"Partners","Assassination",
				"Crazyhouse Four Player","Checkers Four Player",
				"Gold Rush","Revenge"};
		helpList=new JList(games);
		helpList.setVisibleRowCount(10);
		helpList.setSelectedValue(games[0],true);
    	addHelpListener();
    	messages=fourMessages;
    	printMessage.setText(messages[0]);
	}
	public void setToTwoBoard()
	{	chosen=22;
		String[] games={"Bughouse","Team"};
		helpList=new JList(games);
		helpList.setVisibleRowCount(10);
		helpList.setSelectedValue(games[0],true);
    	addHelpListener();
    	messages=twoXTwoMessages;
    	printMessage.setText(messages[0]);
	}
	public void addHelpListener()
	{	helpListener=new MouseListener()
		{	public void mouseClicked(MouseEvent e)
			{	int ind=helpList.getSelectedIndex();
				printMessage.setText(messages[ind]);
			}
	    	public void mousePressed(MouseEvent e){}
			public void mouseReleased(MouseEvent e){}
			public void mouseEntered(MouseEvent e){}
			public void mouseExited(MouseEvent e){}
		};
		helpList.addMouseListener(helpListener);
	}
}