import java.util.Random;
public final class SavedBoards {
	public static String[] classicPieces={"Rook","Knight","Bishop",
		"Queen","King","Bishop","Knight","Rook"},
		newPiecesPieces={"Rook","Knight","Bishop","Queen","King",
		"Penguin","Phoenix","Psychic","Lover","Tank",
		"Grenade","Doppelganger","Chicken"},
		doubledPieces={"Rook","Knight","Bishop","Queen","King",
		"Bishop","Knight","Rook","Penguin","Phoenix","Psychic",
		"Lover","Tank","Grenade","Doppelganger","Chicken"};
	public static Board emptyBoard(int h,int w,boolean rand,
			String gT,int pl)
	{	Board b=new Board();
		b.squares=new Square[h][w];
		for(int i=0;i<h;i++)
			for(int j=0;j<w;j++)
				b.spawnPiece(i, j, "Empty", 0);
		b.height=h;
		b.width=w;
		b.players=pl;
		b.turn=1;
		b.move=1;
		b.incriment=0;
		b.initialTime=0;
		b.currentTime=b.initialTime;
		b.lastX=99;
		b.lastY=99;
		b.forceWin=0;
		if(h>w)b.max=h;
		else b.max=w;
		b.progressiveMoves=0;
		b.numberOfPieceTypes=0;
		b.boardName="Empty";
		b.gameType=gT;
		b.randomized=rand;
		b.noCheck=false;
		b.direction=new int[pl+1];
		for(int i=1;i<=pl;i++)b.direction[i]=i;
		b.points=new int[pl+1];
		for(int i=1;i<=pl;i++)b.points[i]=0;
		b.hand=new Hand(pl);
		if(gT=="Gold Rush")
			for(int i=0;i<h;i++)
				for(int j=0;j<w;j++)
					b.spawnPiece(i, j, "Gold Coin", 5);
		if(gT=="Suicide")b.updateSuicideCapture();
		return b;
	}
	public static Board classic(boolean rand, String gameType,String[] p)
	{	Board b=emptyBoard(8,8,rand,gameType,2);
		b.boardName="Classic";
		b.numberOfPieceTypes=6;
		for(int i=0;i<8;i++)
		{	b.spawnPiece(7, i, p[i], 1);
			b.spawnPiece(0, i, p[i], 2);
			b.spawnPiece(6, i, "Pawn", 1);
			b.spawnPiece(1, i, "Pawn", 2);
		}
		return b;
	}
	public static Board newPieces(boolean rand, String gameType,String[] p)
	{	Board b=emptyBoard(8,13,rand,gameType,2);
		b.boardName="New Pieces";
		b.numberOfPieceTypes=14;
		for(int i=0;i<13;i++)
		{	b.spawnPiece(7, i, p[i], 1);
			b.spawnPiece(0, i, p[i], 2);
			b.spawnPiece(6, i, "Pawn", 1);
			b.spawnPiece(1, i, "Pawn", 2);
		}
		return b;
	}
	public static Board doubled(boolean rand, String gameType,String[] p)
	{	Board b=emptyBoard(10,10,rand,gameType,2);
		b.boardName="Doubled";
		b.numberOfPieceTypes=14;
		for(int i=0;i<10;i++)
		{	if(i<8)
			{	b.spawnPiece(9, i+1, p[i], 1);
				b.spawnPiece(0, i+1, p[i], 2);
				b.spawnPiece(8, i+1, p[i+8], 1);
				b.spawnPiece(1, i+1, p[i+8], 2);
			}
			b.spawnPiece(7, i, "Pawn", 1);
			b.spawnPiece(2, i, "Pawn", 2);
		}
		return b;
	}
	public static Board classicFourPlayer(boolean rand, String gameType,String[] p)
	{	Board b=emptyBoard(12,12,rand,gameType,4);
		b.boardName="Classic Four Player";
		for(int i=0;i<8;i++)
		{	b.spawnPiece(11, 2+i, p[i], 1);
			b.spawnPiece(0, 2+i, p[i], 2);
			b.spawnPiece(2+i, 11, p[i], 3);
			b.spawnPiece(2+i, 0, p[i], 4);
			
			b.spawnPiece(10, i+1, "Pawn", 1);
			b.spawnPiece(1, i+1, "Pawn", 2);
			b.spawnPiece(i+1, 10, "Pawn", 3);
			b.spawnPiece(i+1, 1, "Pawn", 4);
		}
		b.spawnPiece(1, 2, "Farm", 2);
		b.spawnPiece(2, 1, "Farm", 4);
		b.spawnPiece(1, 9, "Farm", 2);
		b.spawnPiece(9, 1, "Farm", 4);
		b.spawnPiece(10, 2, "Farm", 1);
		b.spawnPiece(2, 10, "Farm", 3);
		b.spawnPiece(10, 9, "Farm", 1);
		b.spawnPiece(9, 10, "Farm", 3);
		for(int i=0;i<b.height;i++)
			for(int j=0;j<b.width;j++)
			{	boolean iRight,jRight;
				iRight=i==0||i==1||i==10||i==11;
				jRight=j==0||j==1||j==10||j==11;
				if(iRight&&jRight)
					b.spawnPiece(i, j, "Mountain", 5);
			}
		return b;
	}
	public static Board newPiecesFourPlayer(boolean rand, String gameType,String[] p)
	{	Board b=emptyBoard(17,17,rand,gameType,4);
		b.boardName="New Pieces Four Player";
		for(int i=0;i<13;i++)
		{	b.spawnPiece(16, 2+i, p[i], 1);
			b.spawnPiece(0, 2+i, p[i], 2);
			b.spawnPiece(2+i, 16, p[i], 4);
			b.spawnPiece(2+i, 0, p[i], 3);
			b.spawnPiece(15, 2+i, "Pawn", 1);
			b.spawnPiece(1, 2+i, "Pawn", 2);
			b.spawnPiece(2+i, 15, "Pawn", 4);
			b.spawnPiece(2+i, 1, "Pawn", 3);
		}
		b.spawnPiece(1, 2, "Farm", 2);
		b.spawnPiece(2, 1, "Farm", 3);
		b.spawnPiece(14, 1, "Farm", 3);
		b.spawnPiece(14, 15, "Farm", 4);
		b.spawnPiece(15, 2, "Farm", 1);
		b.spawnPiece(1, 14, "Farm", 2);
		b.spawnPiece(2, 15, "Farm", 4);
		b.spawnPiece(15, 14, "Farm", 1);
		for(int i=0;i<b.height;i++)
			for(int j=0;j<b.width;j++)
			{	boolean iRight,jRight;
				iRight=i==0||i==1||i==15||i==16;
				jRight=j==0||j==1||j==15||j==16;
				if(iRight&&jRight)
					b.spawnPiece(i, j, "Mountain", 5);
		}
		return b;
	}
	
	public static String[] randomize(String[] p)
	{	int length=p.length,i,rInt;
		String[] ret=new String[length];
		for(i=0;i<length;i++)ret[i]="not";
		Random rand=new Random();
		boolean found;
		for(i=0;i<length;i++)
		{	found=false;
			while(!found)
			{	rInt=rand.nextInt(length);
				if(ret[rInt]=="not")
				{	found=true;
					ret[rInt]=p[i];
				}
			}
		}
		return ret;
	}
	public static Board genFromStrings(String m,boolean r,String g)
	{	String[] p={};
		if(m.equals("Classic")||m.equals("Classic Four Player"))
			p=classicPieces;
		if(m.equals("Doubled"))
			p=doubledPieces;
		if(m.equals("New Pieces")||m.equals("New Pieces Four Player"))
			p=newPiecesPieces;
		if(r)p=randomize(p);
		return genFromStrings(m,r,g,p);
	}
	public static Board genFromStrings(String m,boolean r,String g,String[] p)
	{	Board ret=new Board();
		if(m.equals("Classic"))
			ret=classic(r,g,p);
		if(m.equals("New Pieces"))
			ret=newPieces(r,g,p);
		if(m.equals("Doubled"))
			ret=doubled(r,g,p);
		if(m.equals("Classic Four Player"))
			ret=classicFourPlayer(r,g,p);
		if(m.equals("New Four Player"))
			ret=newPiecesFourPlayer(r,g,p);
		if(ret.gameType.equals("Paratrooper"))loadPlane(ret);
		if(ret.gameType.equals("Chaos"))randomize(ret);
		return ret;
	}
	public static void loadPlane(Board b)
	{	for(int i=0;i<b.height;i++)
			for(int j=0;j<b.width;j++)
			{	Square sq=b.square(i,j);
				String n=sq.name;
				if(!sq.empty()&&n!="King")
				{	b.hand.addCapture(n, sq.color);
					b.kill(i, j);
				}
			}
	}
	public static void randomize(Board b)
	{	boolean found=false,tooFarPawn,lastTwoRows=false,checked;
		Random rand=new Random();
		Square sq;Board test;
		int i,j,c,r1,r2,k1=99,k2=99,h=b.height,w=b.width;
		Hand hand=new Hand(2);
		for(i=0;i<h;i++)
			for(j=0;j<w;j++)
			{	sq=b.square(i,j);
				String n=sq.name;
				if(!sq.empty())
				{	hand.addCapture(n, sq.color);
					b.kill(i, j);
				}
			}
		for(c=1;c<=2;c++)
		{	found=false;
			while(!found)
			{	r1=rand.nextInt(h);
				r2=rand.nextInt(w);
				sq=b.square(r1, r2);
				checked=Math.abs(k1-r1)<=1&&Math.abs(k2-r2)<=1;
				if(sq.empty()&&!checked)
				{	b.spawnPiece(r1, r2, "King", c);
					found=true;
					k1=r1;k2=r2;
					hand.drop("King", c);
				}
			}
		}
		for(c=1;c<=2;c++)
		{	while(!hand.empty(c))
			{	found=false;
				String type=hand.randomDrop(c);
				while(!found)
				{	r1=rand.nextInt(h);
					r2=rand.nextInt(w);
					sq=b.square(r1, r2);
					lastTwoRows=(c==1&&r1<3)||(c==2&&r1>b.height-4);
					tooFarPawn=type=="Pawn"&&lastTwoRows;
					if(sq.empty()&&!tooFarPawn)
					{	test=b.returnClone();
						test.spawnPiece(r1, r2, type, c);
						checked=test.inCheck();
						test.turn=2;
						checked=test.inCheck()||checked;
						if(!checked)
						{	b.spawnPiece(r1, r2, type, c);
							found=true;
						}
					}
				}
			}
		}
	}
}
